Imports GrapeCity.SpreadBuilder
Imports GrapeCity.SpreadBuilder.Style
Imports System.Windows.Forms
Imports GrapeCity.ActiveReports
Imports GrapeCity.ActiveReports.Controls
Imports GrapeCity.ActiveReports.SectionReportModel
Imports GrapeCity.ActiveReports.Document.Section
Imports TextBox = GrapeCity.ActiveReports.SectionReportModel.TextBox

Public Class SectionReport1
    Private lbl As New System.Windows.Forms.Label()
    Public Property SpreadBuilderExcelWorkBook() As GrapeCity.SpreadBuilder.Workbook
        Get
            Return m_SpreadBuilderExcelWorkBook
        End Get
        Set(value As GrapeCity.SpreadBuilder.Workbook)
            m_SpreadBuilderExcelWorkBook = value
        End Set
    End Property
    Private m_SpreadBuilderExcelWorkBook As GrapeCity.SpreadBuilder.Workbook
    Private g As Graphics
    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()
        ' Add any initialization after the InitializeComponent() call.
        SpreadBuilderExcelWorkBook = New Workbook()
        g = lbl.CreateGraphics()
        g.PageUnit = GraphicsUnit.Pixel
    End Sub
    Private _rowindex As Integer = 0
    Private _colindex As Integer = 0
    Private _sheetindex As Integer = -1

    Private Sub detail_Format(sender As System.Object, e As System.EventArgs) Handles detail.Format
        For Each ctrl As ARControl In detail.Controls
            If TypeOf ctrl Is TextBox Then
                Dim oldwidth As Integer = SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Columns(CShort(_colindex)).Width
                Dim txt As TextBox = DirectCast(ctrl, TextBox)
                'Multiply by 14.40 to set the width of the column as per text width
                Dim newwidth As Integer = CInt(Math.Truncate(g.MeasureString(txt.Text, txt.Font).Width * (14.4)))
                oldwidth = If((oldwidth > newwidth), oldwidth, newwidth)
                SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Columns(CShort(_colindex)).Width = oldwidth
                SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Cell(_rowindex, _colindex).SetValue(txt.Text)
                _colindex += 1
            End If
        Next
        _rowindex += 1
        _colindex = 0
    End Sub

    'Using the PageStart event to export each page in separate sheet
    'You may use ReportStart event with some modifications, if you want the data in a single sheet
    Private Sub SectionReport1_PageStart(sender As System.Object, e As System.EventArgs) Handles MyBase.PageStart
        SpreadBuilderExcelWorkBook.Sheets.AddNew()
        _sheetindex += 1
        _rowindex = 0
        For Each ctrl As ARControl In detail.Controls
            If TypeOf ctrl Is TextBox Then
                Dim oldwidth As Integer = SpreadBuilderExcelWorkBook.Sheets(0).Columns(CShort(_colindex)).Width
                Dim txt As TextBox = DirectCast(ctrl, TextBox)
                SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Cell(_rowindex, _colindex).FontBold = True
                SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Cell(_rowindex, _colindex).FontSize = 12
                Dim font As New Font(SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Cell(_rowindex, _colindex).FontName, 12, FontStyle.Bold)
                Dim t As Single = g.MeasureString(txt.DataField, font).Width
                Dim newwidth As Integer = CInt(Math.Truncate(t * (14.4)))
                oldwidth = If((oldwidth > newwidth), oldwidth, newwidth)
                SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Columns(CShort(_colindex)).Width = oldwidth
                SpreadBuilderExcelWorkBook.Sheets(_sheetindex).Cell(_rowindex, _colindex).SetValue(txt.DataField)
                _colindex += 1
            End If
        Next
        _rowindex += 1
        _colindex = 0
    End Sub
End Class
